CREATE DATABASE `exim` DEFAULT CHARACTER SET latin1 COLLATE latin1_swedish_ci;
USE exim;


CREATE TABLE `account` (
  `id` int(11) NOT NULL auto_increment,
  `accountname` varchar(255) NOT NULL default '',
  `passwd` varchar(255) default NULL,
  `realname` varchar(255) NULL default 'NULL',
  `accountType` enum('MBOX','FORWARD','PIPE') NOT NULL default 'MBOX',
  `data` text,
  `finaldest` varchar(255) NOT NULL default '',
  `virtual` enum('t','f') NOT NULL default 'f',
  `spamScanType` set('INACTIVE','SPAMFOLDER','MARK','SUBJECT') NOT NULL default 'SPAMFOLDER',
  `virusScanType` set('INACTIVE','SPAMFOLDER','SUBJECT') default 'SPAMFOLDER',
  `isAdmin` enum('t','d','f') NOT NULL default 'f',
  `toActivate` enum('t','f') NOT NULL default 't',
  `toDelete` enum('t','f') NOT NULL default 'f',
  `canModifyAlias` enum('t','f') NOT NULL default 't',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=66 DEFAULT CHARSET=latin1 AUTO_INCREMENT=66 ;

CREATE TABLE `aliases` (
  `id` int(11) NOT NULL auto_increment,
  `accountid` int(11) NOT NULL default '0',
  `domainid` int(11) NOT NULL default '0',
  `aliasname` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=134 DEFAULT CHARSET=latin1 AUTO_INCREMENT=134 ;

CREATE TABLE `awl` (
  `username` varchar(100) NOT NULL default '',
  `email` varchar(200) NOT NULL default '',
  `ip` varchar(10) NOT NULL default '',
  `count` int(11) default '0',
  `totscore` float default '0',
  PRIMARY KEY  (`username`,`email`,`ip`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `bayes_expire` (
  `id` int(11) NOT NULL default '0',
  `runtime` int(11) NOT NULL default '0',
  KEY `bayes_expire_idx1` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `bayes_global_vars` (
  `variable` varchar(30) NOT NULL default '',
  `value` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`variable`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `bayes_seen` (
  `id` int(11) NOT NULL default '0',
  `msgid` varchar(200) character set latin1 collate latin1_bin NOT NULL default '',
  `flag` char(1) NOT NULL default '',
  PRIMARY KEY  (`id`,`msgid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `bayes_token` (
  `id` int(11) NOT NULL default '0',
  `token` char(5) NOT NULL default '',
  `spam_count` int(11) NOT NULL default '0',
  `ham_count` int(11) NOT NULL default '0',
  `atime` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`,`token`),
  KEY `bayes_token_idx1` (`token`),
  KEY `bayes_token_idx2` (`id`,`atime`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `bayes_vars` (
  `id` int(11) NOT NULL auto_increment,
  `username` varchar(200) NOT NULL default '',
  `spam_count` int(11) NOT NULL default '0',
  `ham_count` int(11) NOT NULL default '0',
  `token_count` int(11) NOT NULL default '0',
  `last_expire` int(11) NOT NULL default '0',
  `last_atime_delta` int(11) NOT NULL default '0',
  `last_expire_reduce` int(11) NOT NULL default '0',
  `oldest_token_age` int(11) NOT NULL default '2147483647',
  `newest_token_age` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `bayes_vars_idx1` (`username`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1 AUTO_INCREMENT=5 ;

CREATE TABLE `domain` (
  `id` int(11) NOT NULL auto_increment,
  `domainname` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=20 DEFAULT CHARSET=latin1 AUTO_INCREMENT=20 ;

CREATE TABLE `userpref` (
  `prefid` int(11) NOT NULL auto_increment,
  `accountname` varchar(250) NOT NULL default '',
  `preference` varchar(250) NOT NULL default '',
  `value` text NOT NULL,
  PRIMARY KEY  (`prefid`),
  KEY `accountname` (`accountname`,`preference`)
) ENGINE=MyISAM AUTO_INCREMENT=220 DEFAULT CHARSET=latin1 AUTO_INCREMENT=220 ;

INSERT INTO `bayes_global_vars` (`variable`, `value`) VALUES ('VERSION', '3');
INSERT INTO `bayes_vars` (`id`, `username`, `spam_count`, `ham_count`, `token_count`, `last_expire`, `last_atime_delta`, `last_expire_reduce`, `oldest_token_age`, `newest_token_age`) VALUES (4, 'nobody', 25535, 12706, 171155, 1192567756, 0, 0, 1133027177, 1192605169);
