#!/usr/bin/perl

################################################################################
#    Config 1.0. Configuration Server for an Exim Mailsystem                   #
#    Using DB Framwork for PHP  1.1.                                           #
#    Copyright (C) 2006 Luca Bertoncello                                       #
#    Hartigstrasse, 12 - 01127 Dresden Deutschland                             #
#    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       #
#    http://www.lucabert.de/  http://www.lucabert.com/                         #
#                                                                              #
#    This program is free software; you can redistribute it and/or modify      #
#    it under the terms of the GNU General Public License as published by      #
#    the Free Software Foundation; version 2 of the License.                   #
#                                                                              #
#    This program is distributed in the hope that it will be useful,           #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#    GNU General Public License for more details.                              #
#                                                                              #
#    You should have received a copy of the GNU General Public License         #
#    along with this program; if not, write to the Free Software               #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
################################################################################

use DBI;
use File::Basename;

if($ARGV[0] eq '')
{
  print "Usage:\nmanageAccount.pl <path to config.inc.php>\n";
  exit(-1);
}

open(CFG, $ARGV[0]);
@cfgs = <CFG>;
close(CFG);
$user = getConfigVar('eximUser', @cfgs);
$dbHost = getConfigVar('dbHost', @cfgs);
$dbUser = getConfigVar('dbUser', @cfgs);
$dbPass = getConfigVar('dbPass', @cfgs);
$dataBase = getConfigVar('dataBase', @cfgs);
$maildirSpamPath = getConfigVar('maildirSpamPath', @cfgs);

($mailDB = DBI->connect("DBI:mysql:dbname=$dataBase;host=$dbHost", $dbUser, $dbPass)) or die DBI::errstr;

# Create new accounts
$sth = $mailDB->prepare("SELECT accountname, finaldest FROM account WHERE virtual = 'f' AND toActivate = 't'");
($sth->execute()) or die "ERROR: Query failed.\n";
while((@values = $sth->fetchrow()))
{
  $accountname = $values[0];
  $finaldest = $values[1];
  ($login, $pass, $uid, $gid, $quota, $comment, $gcos, $homedir, $shell, $expire) = getpwnam($accountname);
  print "Create [$accountname]...\n";
  system("/bin/mkdir -p $homedir");
  chown $uid, $gid, "$homedir";
  chmod 0750, "$homedir";
  ($login, $pass, $uid, $gid) = getpwnam($user);
  system("/bin/mkdir -p $finaldest/new");
  system("/bin/mkdir -p $finaldest/cur");
  system("/bin/mkdir -p $finaldest/tmp");
  system("/bin/mkdir -p $finaldest/.Sent/new");
  system("/bin/mkdir -p $finaldest/.Sent/cur");
  system("/bin/mkdir -p $finaldest/.Sent/tmp");
  system("/bin/mkdir -p $finaldest/.$maildirSpamPath/new");
  system("/bin/mkdir -p $finaldest/.$maildirSpamPath/cur");
  system("/bin/mkdir -p $finaldest/.$maildirSpamPath/tmp");
  system("/bin/mkdir -p $finaldest/.Trash/new");
  system("/bin/mkdir -p $finaldest/.Trash/cur");
  system("/bin/mkdir -p $finaldest/.Trash/tmp");
  chmod 0750, "$finaldest";
  chown $uid, $gid, "$finaldest";
  chown $uid, $gid, "$finaldest/new";
  chown $uid, $gid, "$finaldest/cur";
  chown $uid, $gid, "$finaldest/tmp";
  chown $uid, $gid, "$finaldest/.Sent";
  chown $uid, $gid, "$finaldest/.Sent/new";
  chown $uid, $gid, "$finaldest/.Sent/cur";
  chown $uid, $gid, "$finaldest/.Sent/tmp";
  chown $uid, $gid, "$finaldest/.$maildirSpamPath";
  chown $uid, $gid, "$finaldest/.$maildirSpamPath/new";
  chown $uid, $gid, "$finaldest/.$maildirSpamPath/cur";
  chown $uid, $gid, "$finaldest/$maildirSpamPath/tmp";
  chown $uid, $gid, "$finaldest/.Trash";
  chown $uid, $gid, "$finaldest/.Trash/new";
  chown $uid, $gid, "$finaldest/.Trash/cur";
  chown $uid, $gid, "$finaldest/.Trash/tmp";
  open(SUB, "> $finaldest/subscriptions");
  print SUB "Trash\n$maildirSpamPath\nSent\n";
  close(SUB);
  chown $uid, $gid, "$finaldest/subscriptions";
  $sthU = $mailDB->prepare("UPDATE account SET toActivate = 'f' WHERE accountname = '$accountname'");
  ($sthU->execute()) or die "ERROR: Query failed.\n";
  $sthU->finish();
}
$sth->finish();

# Delete old accounts
$sth = $mailDB->prepare("SELECT accountname, id, finaldest FROM account WHERE toDelete = 't'");
($sth->execute()) or die "ERROR: Query failed.\n";
while((@values = $sth->fetchrow()))
{
  $accountname = $values[0];
  $accountid = $values[1];
  $finaldest = $values[2];
  print "Delete [$accountname]...\n";
  ($login, $pass, $uid, $gid, $quota, $comment, $gcos, $homedir, $shell, $expire) = getpwnam($accountname);
  system("/bin/rm -Rf $homedir");
  system("/bin/rm -Rf $finaldest");
  $sthU = $mailDB->prepare("DELETE FROM aliases WHERE accountid = '$accountid'");
  ($sthU->execute()) or die "ERROR: Query failed.\n";
  $sthU->finish();
  $sthU = $mailDB->prepare("DELETE FROM account WHERE accountname = '$accountname'");
  ($sthU->execute()) or die "ERROR: Query failed.\n";
  $sthU->finish();
}
$sth->finish();

$mailDB->disconnect();

sub getConfigVar
{
  my($varName, @cfgs) = @_;

  @fs = grep(/\$$varName/, @cfgs);
  $v = $fs[$#fs];
  $v =~ s/[\n\r]//g;
  ($x, $var) = split(/=/, $v);
  $var =~ s/\ //g;
  $var =~ s/\;//g;
  $var =~ s/\'//g;

  return($var);
}
